import * as CompilerDOM from '@vue/compiler-dom';
/**
 * @param templateAst Use `require('@vue/compiler-dom').compile` or `require('@volar/vue-code-gen').compileTemplate`, provide to resolve variables unused in script setup
 * @param cssVars Use `require('@vue/compiler-sfc').parseCssVars`, provide to resolve variables unused in script setup
 * @param vueLibName Where should `defineComponent` and `PropType` import from? (For example: `vue`, `@vue/runtime-dom`, `@vue/composition-api`)
 */
export declare function generateSFCScriptTypeCheckCode(ts: typeof import('typescript/lib/tsserverlibrary'), scriptLang: 'js' | 'jsx' | 'ts' | 'tsx', scriptCode: string | undefined, scriptSetupCode: string | undefined, templateAst?: CompilerDOM.RootNode, cssVars?: string[], vueLibName?: string): {
    code: string;
    scriptMappings: {
        sourceTextRange: import("@volar/source-map").Range;
        generatedTextRange: import("@volar/source-map").Range;
    }[];
    scriptSetupMappings: {
        sourceTextRange: import("@volar/source-map").Range;
        generatedTextRange: import("@volar/source-map").Range;
    }[];
};
/**
 * A wrapper function of `require('@vue/compiler-dom').compile`
 */
export declare function compileSFCTemplate(htmlCode: string, options?: CompilerDOM.CompilerOptions, vueVersion?: 2 | 3): {
    errors: CompilerDOM.CompilerError[];
    warnings: CompilerDOM.CompilerError[];
    ast: CompilerDOM.RootNode | undefined;
};
